/*   Determine the remote IP of a connection connecting to an inetd service.
 *   Copyright (C) 2001 Robert Davidson.
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *   Written by Robert Davidson, E-Mail: acua@acua.ebbs.com.au
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <signal.h>
#include <syslog.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <time.h>
#include "radutmp.h"

#define Version 	"1.00"

#ifndef RADUTMP
#define RADUTMP 	"/var/log/radutmp"
#endif

/* Define this if you want logging enabled. Logging is done via syslog() */
/* Set the below to be "1", otherwise "0" to not log anything. */
#define LOGGING                  1

/* ----------------------------------------------------------------------- */
/* - Start Of Program. --------------------------------------------------- */
/* ----------------------------------------------------------------------- */

int main()
{

char   UserName[35]="", fa[25], ia[25], port[6];
struct sockaddr_in sai;
struct in_addr	   ina;
struct radutmp     rt;
FILE   *fp;
size_t sv = sizeof(sai);

/* Figure out the remote IP Address */
if (getpeername(0, (struct sockaddr *) &sai, &sv) < 0)
     { printf("\ngetpeername() Failed!\n");
       fflush(stdout);
       exit(1);
     }

// From their IP Address, figure out who the user is..
if ((fp = fopen(RADUTMP, "r")))
{
    // read and compare the logins.
    UserName[0] = '\0';
    while(fread(&rt, sizeof(rt), 1, fp) == 1) {
      // if they match and are logged on...
      if (rt.type == 1) {
        ina.s_addr = rt.framed_address;
        sprintf(fa, "%s", inet_ntoa(ina));
//  sprintf(fa, "%s", inet_ntoa((struct in_addr) rt.framed_address));
        sprintf(ia, "%s", inet_ntoa(sai.sin_addr));
        if (!strcmp(fa, ia)) 
	{
	    sprintf(UserName, "%s", rt.login);
	    sprintf(port, "S%i", rt.nas_port);
	}
      }
    }
}
// if we didn't find a match..
if (UserName[0] != '\0')
{
    printf("%s %s %s\n", inet_ntoa(sai.sin_addr), UserName, port);
} else {
    printf("%s\n", inet_ntoa(sai.sin_addr));
}

return(0);
}

